% FONTANA FEDERICO
%MATR: 597731

%Parte 1: acquisizione del segnale:

s0=0.2;% ampiezza,V
f=6; % Hz, frequenza segnale
fc=150; %Hz, frequenza campionamento;
fi=40/360*2*pi;% fase
T=1;% s, tempo totale di acquisizione;

p=1/fc;% passo;
t=[0:p:T];


%GENERAZIONE DEL SEGNALE CAMPIONATO:

s=s0*cos(2*pi*f*t+fi); % generazione del segnale campionato;


figure (1);
plot(t,s);
title('SEGNALE CAMPIONATO');
xlabel('tempo (s)');
ylabel('ampiezza (V)');
text(50,50,'segnale campionato');



% PARTE 2: DERIVAZIONE DEL SEGNALE:

Ds_E=deriv_Eulero(t,s); %derivata prima;
DDs_E=deriv_Eulero(t,Ds_E); %derivata seconda;

Ds_I=deriv_Interpolata(t,s,fc);
DDs_I=deriv_Interpolata(t,Ds_I,fc);

figure (2);
plot(t,DDs_E,'-b');
hold on;
plot(t,DDs_I,'-g');
title('CONFRONTO DERIVATE');
xlabel('tempo (s)');
ylabel('ampiezza (V)');


% PARTE 3: ATTENUAZIONE SEGNALE

%ampiezza teorica:
At=s0*4*pi*pi*f*f;

%ampiezza Eulero:
vE=DDs_E(20:length(DDs_E));%elimino i primi punti con valore instabile
max_E=max(vE);
min_E=min(vE);
A_E=(max_E-min_E)/2;

%ampiezza Inrterpolata:
vI=DDs_I(20:length(DDs_I));%elimino i primi punti con valore instabile
max_I=max(vI);
min_I=min(vI);
A_I=(max_I-min_I)/2;

figure(3);
plot(1,At,'*b',2,A_E,'*g',3,A_I,'*r');
title('1= amp.teotica, 2= amp.Eulero, 3= amp. derivata interpolata');


% PARTE 4: INTRODUZIONE DISTURBO

%generazione disturbo:

fd=50; %Hz, freq disturbo
d0=0.001; % V, amp disturbo;
d=d0*sin(2*pi*fd*t);

sd=s+d;

% Derivazione segnale disturbato:

Dsd_E=deriv_Eulero(t,sd);
DDsd_E=deriv_Eulero(t,Dsd_E);

Dsd_I=deriv_Interpolata(t,sd,fc);
DDsd_I=deriv_Interpolata(t,Dsd_I,fc);


figure(4);

plot(t,DDsd_E,'-b');
hold on;
plot(t,DDsd_I,'-g');
xlabel('tempo (s)');
ylabel('ampiezza (V)');
title('SEGNALE DISTURBATO');






